package com.mhsoftware.cdaily.support.security;
/*
	connectDaily Web Calendar Software

	Copyright 2002-2006, MH Software, Inc. All Rights Reserved
	5023 W 120th Ave #311, Broomfield CO 80020
	+1 303 438 9585

	Last Edit By: "$Author: gsexton $"
	Last Checkin: "$Date: 2018/03/02 18:42:08 $"
	Revision #  : "$Revision: 1.14 $"

*/

import java.util.List;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.servlet.ServletContext;

import com.MHSoftware.string.StringUtil;
import com.mhsoftware.cdaily.business.User;

/**
*	This class implements AuthenticationProvider
*	and is the default authentication provider for
*	ConnectDaily. By default, it uses the UserClass
*	to locate a user with the supplied User ID and
*	password.
*
*   @author George Sexton
*/

public class AuthProviderDefault extends AuthenticationProvider {

	public AuthProviderDefault(){
		// nothing
	}

	public AuthProviderDefault(ServletContext sc) {
		super();
	}


	public LoginResult authenticateUser(String UserID, String Password, String TransFormSeed, ResourceBundle rb, Locale lc) {
		lr = new LoginResult();
		return lr;
	}

	public LoginResult authenticateUser(String UserID, String Password, ResourceBundle rb, Locale lc) {

		lr = new LoginResult();
		User u = User.getUserByName(UserID);
		if (u == null) {
			lr.getFatalList().add(rb.getString("InvalidUserOrPW"));
		} else {
			lr.setUser(u);
			List l = verifyLoginPreconditions(u, rb);
			if (l.isEmpty()) {
				String sPassword = transformPassword(Password);
				if (u.password.equals(sPassword)) {
					processSuccessfulLogin(u, rb, lc);
				} else {
					processFailedLogin(u, rb);
				}
			}

		}
		return lr;
	}

	public boolean transformedMatchesThisProvider(String transformed) {
		return !StringUtil.isEmpty(transformed);
	}

	public int getProviderFlags() {
		return AuthenticationProvider.PLAINTEXT_PW_AVAILABLE | AuthenticationProvider.CHANGES_PASSWORDS;
	}
}


